//
//  CameraShader.fsh
//  ObviousDemo
//
//  Copyright 2012 Obvious Engine. All rights reserved.
//

uniform sampler2D textureY;
uniform sampler2D textureUV;
varying mediump vec2 texcoord;

void main()
{
    mediump float y = 1.1643*(texture2D(textureY,texcoord).r-0.0625);
    mediump vec2 uv = texture2D(textureUV, texcoord).ra - vec2(0.5);
    
    mediump float r = clamp(y+1.6023*uv.y, 0.0, 1.0);
    mediump float g = clamp(y-0.3932*uv.x-0.8160*uv.y, 0.0, 1.0);
    mediump float b = clamp(y+2.025*uv.x, 0.0, 1.0);

    gl_FragColor=vec4(r,g,b,1.0);
}
