//
//  WarpShader.fsh
//  ObviousDemo
//
//  modifications by visy
//  Copyright 2012 Obvious Engine. All rights reserved.
//

uniform sampler2D textureY;
uniform sampler2D textureUV;

varying mediump float timer;
varying mediump vec2 texcoord;

// this is the same as the camera shader for now
void main()
{
    mediump float y = 1.1643*(texture2D(textureY,texcoord).r-0.0625);
    mediump vec2 uv = texture2D(textureUV, texcoord).ra - vec2(0.5);
    
    y = y * gl_FragCoord.x*0.001+texcoord.x;
    
    mediump float r = clamp(y+1.6023*uv.y+cos(uv.x+timer+sin(uv.y*timer)), 0.0, 1.0);
    mediump float g = clamp(y-0.3932*uv.x-0.8160*uv.y+tan(uv.x+texcoord.x*texcoord.y*timer*0.1), 0.0, 1.0);
    mediump float b = clamp(y+2.025*uv.x+sin(uv.y*0.5+timer)*cos(uv.x+uv.y*timer), 0.0, 1.0);
    
    gl_FragColor=vec4(r,g,b,1.0);
}
