//
//  WarpShader.vsh
//  ObviousDemo
//
//  modifications by visy
//  Copyright 2012 Obvious Engine. All rights reserved.
//

attribute vec3 position;
attribute vec3 displacement;

uniform mat4 modelviewMatrix;
uniform mat4 projectionMatrix;
uniform float time;
uniform float scale;
uniform bool isCylindrical;
uniform float stretchFactor;

varying vec2 texcoord;
varying float timer;

void main()
{
    mediump vec4 truePosition = projectionMatrix * modelviewMatrix * vec4(position, 1.0);
    if (isCylindrical)
    {
        mediump float s = 0.01*scale*(1.0+ cos(5.0*position.x+time+position.z))*sin((0.5+position.z+(position.x*cos(time)*0.01))*3.141)*atan(position.y+time)*0.4;
        gl_Position = projectionMatrix * modelviewMatrix * vec4(position+s*displacement, 1.0);
    }
    else
    {
        mediump float s = cos(time+position.y)*scale*1.3;
        gl_Position = projectionMatrix * modelviewMatrix * vec4(position*s, 1.0);
    }
    
    // figure out the texcoord of the unwarped vertex
    texcoord = vec2(-truePosition.y/truePosition.w, -truePosition.x/truePosition.w/stretchFactor)*0.5 + vec2(0.5);
    
    timer = time;
}
