//
//  ViewController.h
//  ObviousDemo
//
//  Copyright 2012 Obvious Engine. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <GLKit/GLKit.h>
#import <AVFoundation/AVFoundation.h>

#import <ObviousEngine.h>

// there's no camera emulation in the simulator, so set this to 0
// to run from a static image (using TARGET_OS_EMBEDDED does this
// automatically based on whether you're building for device or
// simulator).
#define USE_CAMERA TARGET_OS_EMBEDDED
//#define USE_CAMERA (1)


#if USE_CAMERA
@interface ViewController : GLKViewController <AVCaptureVideoDataOutputSampleBufferDelegate>
#else
@interface ViewController : GLKViewController
#endif
{
@private

#if USE_CAMERA
    AVCaptureSession *captureSession;
    AVCaptureDevice *cameraDevice;
    AVCaptureVideoDataOutput *dataOutput;
    dispatch_queue_t captureQueue;
#endif

    NSLock *arSystemLock;
    ObviousEngine *arSystem;
    // bit of a hack to forward-declare a c++ class
    struct ARRenderer *renderer;
    
    int lostFrames;
    int trackedFrames;
    float objectScale;
    
    UILabel *modelLabel;
    NSTimer *modelLabelTimer;
    NSArray *modelFiles;
    int activeModel;
    int modelHandle;
}

@property (nonatomic, retain) IBOutlet UILabel *modelLabel;

@end
